

/*
D:\Dev_Cpp
Speicherort 
MinGW erneuern

https://www.tutorials.de/threads/grafiken-zeichnen-in-der-konsole.194602/
https://sourceforge.net/projects/orwelldevcpp/files/Compilers/MinGW/

libgdi32.a mit dazulinken:
Unter Projektoptionen->Parameter->Linker whlst du aus dem lib Verzeichnis von DevCpp einfach die o.g. lib aus.

libgdi32.a liegt Bsp: zugleich als 64 und 32 Bit version unter
C:\Program Files (x86)\Dev-Cpp\MinGW64\x86_64-w64-mingw32\lib
C:\Program Files (x86)\Dev-Cpp\MinGW64\x86_64-w64-mingw32\lib32
*/

#pragma comment(lib,"libgdi32.a")   // einbinden von lib

#include <windows.h>
#include <iostream>
#include <limits>
#include <stdexcept>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>

#include "main.h"

//#include <time.h>

using namespace std;

// FENSTER PIXEL GROESSE
// ------------------------
#define WIN_X_WIDTH 	1024
#define WIN_Y_WIDTH		1024

#define WIN_X_MITTE		512
#define	WIN_Y_MITTE		512

#define COULOUR_MAX_VAL	16777216UL
// ------------------------

//GLOBAL
HWND hWnd;
HDC hDC;
unsigned char u8Rot, u8Gruen, u8Blau;


// ******************************
void KreuzZeichnen(void)
// ******************************
{
uint16_t u16NN;
//KREUZ
for( u16NN = 0 ; u16NN < WIN_X_WIDTH ; u16NN++)
	{
	SetPixel(hDC, u16NN, WIN_Y_MITTE, RGB(255, 255, 255));				
	};

for( u16NN = 0 ; u16NN <WIN_Y_WIDTH ; u16NN++)
	{
	SetPixel(hDC, WIN_X_MITTE, u16NN, RGB(255, 255, 255));				
	};
};

// ******************************
void PLotX_ToY( double dXX, double  dYY)
// ******************************
{
uint16_t u16WIN_X = round( dXX ) + WIN_X_MITTE;
uint16_t u16WIN_Y = (round( dYY ) * -1.0) + WIN_Y_MITTE;

if( u16WIN_Y  <= WIN_Y_WIDTH )
	{
	SetPixel(hDC, u16WIN_X, u16WIN_Y , RGB(255, 255, 255));				
	}
};



//Fraktalberechnung
// ****************************************************************
void FunktionX( void )
// ****************************************************************
{
float f16XX;
float f16YY;

system("cls"); 

KreuzZeichnen();

for( f16XX = -512 ; f16XX < WIN_X_WIDTH ; f16XX+=0.1)
	{
	// F(x) = 2X^2+5
	f16YY = round( (f16XX * f16XX) /  50.0 + 50  );
	PLotX_ToY( f16XX, f16YY );
	
	f16YY = round( 2/50.0 * (2*f16XX));
	PLotX_ToY( f16XX, f16YY );
	};

};


int main(void)
{

SetConsoleTitle("FunktionX");
   //HWND hWnd = FindWindow(NULL, "Grafik in Dos");
    //alternative zu FindWindow 
hWnd = GetConsoleWindow();
//MoveWindow(hWnd,100,100,windowWidth,windowHeight,FALSE);
if( hWnd != NULL ){ MoveWindow(hWnd ,100,100 ,WIN_X_WIDTH, WIN_Y_WIDTH ,TRUE); }
//console con( 80, 200 );
/*
SetConsoleScreenBufferSize
SetConsoleWindowInfo
*/
	hDC = GetDC(hWnd);         

 	FunktionX();
	
	ReleaseDC(hWnd, hDC);
    DeleteDC(hDC);
    //std::cin.get();
    system("pause");   
	return 0;        
};/* run this program using the console pauser or add your own getch, system("pause") or input loop */





